%To Generate NewtonJPD2 (or NewtonJPD.eps)
%Run via matlab for production (not Octave)

set(0,'defaultAxesFontSize',14)
clear all;close all;clc;more off;
c=[':.b'; ':sr'; ':og'; ':pm'; ':.k'; ':sc']; %Colors for plotting

%Define up to four roots:
%R=[1 2 3 4];% JPD suggested this case: update: print -dpdf NewtonJPD
R=[1+.5j, 2-.5j, 3-j, 4+j/2, 3+j]; %update print -dpdf NewtonJPD2

A=diag(R);
P=poly(A);
P1=polyder(P);
R=roots(P);
R1=roots(P1);
sprintf('Roots: %g, %g, %g, %g, %g\n\n',R)
sprintf('Roots: %g, %g, %g, %g, %g\n\n',R1);

y=[]; x=1+eps*j; k=0; kmax=1000;

  while k<=kmax; %stop after kmax trials
k=k+1;
%clc;

%Now apply Newton method;
%Define starting value
%x0=input('starting value=');
%n=1;x(1)=x0+1e-6j;
x=6*(rand(1))  +3*(rand(1)-.5)*j;
%x=conj(x);

y=[];
	for n=1:10
y(n)=x; %save sequence
x = x - 0.5*polyval(P,x)./polyval(P1,x);
%Plot results
%plot(y,c(rn,:),'MarkerSize',2); hold on; grid on;
%plot(1:length(R),R,'x','MarkerSize',5);hold on
	end %for

  rn=round(abs(real(y(end)))); %Bad code: This is used as an index to c(rn). root must have int real part

  if rn < 1 || rn > 5; rn =5;end

	if max(abs(y))<5 %avoid large values
  plot(y,c(rn,:),'MarkerSize',2); hold on; grid on;
  xlabel('\Re x'); ylabel('\Im x');
  xlim([0 5]);ylim([-2 2]);
	end
  
%drawnow;%hold off;
%disp(sprintf('y(end)=%g\n',real(y(end))));drawnow;
%pause(0.1); %input('Any key to continue');
  end %while

%print -depslatex junk
print -depsc2 NewtonJPD2
%print -dpdf NewtonJPD
